<template>
  <nav class="bg-primary navbar navbar-dark navbar-expand sticky-top">
    <div class="container-fluid">
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" href="/"
            ><i class="fas fa-caret-left"></i> Back to Airflow
          </a>
        </li>
      </ul>

      <ul class="navbar-nav">
        <li class="nav-item">
          <router-link class="nav-link" to="/">Project</router-link>
        </li>
        <li class="nav-item">
          <router-link class="nav-link" to="/sandbox">Sandbox</router-link>
        </li>
        <li class="nav-item">
          <router-link
            :class="`nav-link ${
              $route.name === 'Vault'
                ? 'router-link-active router-link-exact-active'
                : ''
            }`"
            to="/vault"
            >Vault</router-link
          >
        </li>
        <li class="nav-item">
          <router-link
            :class="`nav-link ${
              $route.name === 'Storage'
                ? 'router-link-active router-link-exact-active'
                : ''
            }`"
            to="/storage"
            >Storage</router-link
          >
        </li>
      </ul>
      <ul class="navbar-nav">
        <li class="nav-item dropdown">
          <a
            href="#"
            class="navbar-profile nav-link dropdown-toggle py-0"
            @click.prevent="displayUser = !displayUser"
          >
            <img
              :src="userInfo?.picture"
              :alt="userInfo?.name || 'not logged in'"
            />
          </a>
          <ul :class="`dropdown-menu ${displayUser ? 'd-block' : ''}`">
            <li class="dropdown-item pe-none">
              <code>{{ userInfo?.name }} &lt;{{ userInfo?.email }}&gt;</code>
            </li>
            <li><hr class="dropdown-divider" /></li>
            <li class="dropdown-item">
              <a href="#" class="nav-link" @click="logout">Logout</a>
            </li>
          </ul>
        </li>
        <li class="nav-link position-relative">
          <a
            :class="`navbar-tasks nav-link ${taskListVisible ? 'active' : ''} ${
              tasksRunning ? 'running' : ''
            }`"
            href="#"
            @click.prevent="toggleTaskList"
            ><i
              :class="`fas ${
                taskListVisible ? 'fa-times' : 'fa-clipboard-list'
              }`"
            ></i
          ></a>
          <slot name="tasklist"></slot>
        </li>
      </ul>
    </div>
    <api-data endpoint="/auth/" v-model="userInfo" />
  </nav>
</template>

<script>
export default {
  name: "TopNavbar",
  emits: ["toggleTaskList"],
  mounted() {
    setInterval(() => {
      this.tasksRunning = this.$root.$refs.taskList?.getRunning();
    }, 3000);
  },
  data() {
    return {
      taskListVisible: false,
      userInfo: {},
      tasksRunning: false,
      displayUser: false,
    };
  },
  methods: {
    toggleTaskList() {
      this.taskListVisible = !this.taskListVisible;
      this.$emit("toggleTaskList", this.taskListVisible);
    },
    logout() {
      const url = `${this.apiUrl}/auth/logout`;
      import("axios").then(({ default: axios }) => {
        axios
          .get(url, { withCredentials: true })
          .then(() => {
            this.notify("Logged out", "Success", "success");
            window.location.href = "/";
          })
          .catch((error) =>
            this.notify(
              error || "Unexpected error occurred",
              error?.name || "Error",
              "error"
            )
          );
      });
    },
  },
};
</script>

<style lang="scss">
nav {
  .nav-link {
    padding-top: 0;
    padding-bottom: 0;
  }
  a.navbar-tasks {
    font-size: 2rem;
    vertical-align: middle;
    position: relative;
    &.active {
      color: rgba(0, 0, 0, 0.7);
    }
    &.running::after {
      display: block;
      position: absolute;
      top: 0;
      right: 0.5rem;
      content: "\f110";
      font-weight: 900;
      font-size: 1.5rem;
      font-family: "Font Awesome 5 Free";
      animation: rotate-cog 1000ms ease-in-out infinite;
      color: black;
    }
  }
  height: 4rem;
  line-height: 4rem;
  ul.dropdown-menu {
    line-height: 1.5rem;
    left: 0;
    transform: translate(-80%, 0);
    .nav-link {
      color: #7f2174;
    }
  }
  ul li a {
    text-decoration: none;

    &.router-link-active {
      font-weight: bold;
    }
  }

  .navbar-profile {
    img {
      border-radius: 50%;
    }
  }
}
</style>
